unit busca_antiga;

interface
uses windows, sysutils, shellApi, classes,
     dvcrt, dvWin, dvInet, dvArq, dvForm, dvExec, dvSsl, winsock,
     gvHttp, gvHtml, gvVars, gvMsg;

procedure buscaNoGoogle (busca: string; nivelDeBusca: integer);

implementation

{--------------------------------------------------------}
{            faz uma pesquisa pelo site                  }
{--------------------------------------------------------}

function trazDoGoogle (busca: string; pagInicio: integer): string;
var
    httpMsg, cook, s: string;
    i, status: integer;
begin
    httpMsg :=
            'GET ' + '/search' +
                     '?ie=ISO%2D8859%2D1'+
                     '&q=' + UrlEncode2(busca) +
                     '&start=' + intToStr (pagInicio*10)+
                     '&hl=pt'+
                     '&source=hp'+
                     '&biw='+
                     '&bih=' +
                     '&btnG=Pesquisa+Google'+
                     '&gbv=' + intToStr(pagInicio+1) +
                     ' HTTP/1.0' + ^m^j +
            'Host: ' + siteGoogle + ^m^j +
            'Accept-Language: pt-br' + ^m^j +
            'UA-CPU: x86' + ^m^j +
            'User-Agent: GoogleVox 2.0' + ^m^j;

    for i := 0 to cookies.count-1 do
        begin
            cook := copy (cookies[i], 1, pos(';', cookies[i])-1);
            httpMsg := httpMsg + 'Cookie=' + cook + ^m^j;
        end;

    httpMsg := httpMsg + ^m^j;

    if debug then
        begin
            textColor (GREEN);
            writeln ('Site:   ', siteGoogle);
            writeln ('URL:    ', urlGoogle);
            for i := 0 to cookies.count-1 do
                writeln ('Cookie: ', cookies[i]);
            textColor (WHITE);
            write ('Aperte enter');
            readln;
            writeln;
        end;

    s := httpTransport (siteGoogle, 80, httpMsg, status, newLocation, cookies);

    if status <> 200 then
        begin
            mensagem ('GVPRBGOO', 2);  {'Comunicao com a Google no foi estabelecida'}
            s := '';
            exit;
        end;

    result := s;
end;

{-----------------------------------------------------------}
{          rotinas de criao e exibio da janela
{-----------------------------------------------------------}

procedure adicionaAosUltimos (chaveBusca: string);
var i, j: integer;
begin
    for i := 1 to 10 do
        begin
            if chaveBusca = ultimasBuscas[i] then
                begin
                    for j := i to 10-1 do
                        ultimasBuscas[j] := ultimasBuscas[j+1];
                    ultimasBuscas[10] := '';
                end;
        end;

    if (chaveBusca <> '') and (chaveBusca <> ultimasBuscas[1]) then
       begin
           for i := 10 downto 2 do
               ultimasBuscas[i] := ultimasBuscas[i-1];
           ultimasBuscas[1] := chaveBusca;
           for i := 1 to 10 do
               sintGravaAmbiente ('GOOGLEVOX', intToStr(i), ultimasBuscas[i]);
       end;
end;

{--------------------------------------------------------}
{                      faz uma busca                     }
{--------------------------------------------------------}

procedure buscaNoGoogle (busca: string; nivelDeBusca: integer);
var
    nn : integer;
    s: string;
    i, j: integer;
    p: integer;
    numRegLidos: integer;
    sl: TStringList;
    titulo: string;
    url: string;
    descricao: string;
    transf: string;
    proxCmdBusca: string;

begin
    proxCmdBusca := '';
    numRegLidos := 0;

    for nn := 0 to nivelDeBusca-1 do
        begin
            s := trazDoGoogle (busca, nn);

            if s <> '' then
                begin
                    sl := TStringList.create;
                    sl.assign (HTMLparaStringList(s));
                    for i := sl.count-1 downto 0 do
                        if trim(sl[i]) = '' then
                             sl.Delete(i);

                    if debug then
                        sl.SaveToFile('c:\temp\' + UrlEncode2(busca) + '_' + intToStr(nn) + '.htm');

                    i := 0;
                    while i < sl.count do
                        begin
                            if (pos ('<a href="/url?', sl[i]) = 1) and
                               (sl[i+2][1] <> '<') then
                                begin
                                    url := copy (sl[i], 10, 9999);
                                    delete (url, 1, 7);
                                    p := pos ('&amp;', LowerCase(url));
                                    delete (url, p, length(url)-p+1);

                                    titulo := sl[i+2];

                                    descricao := '';
                                    transf := '';
                                    for j := i+1 to sl.count-1 do
                                        begin
                                            if pos ('<a href="/url?', sl[j]) = 1 then break;
                                            if (sl[j] <> '') and (sl[j][1] <> '<') then
                                                if (transf = '') and (upperCase(copy (sl[j], 1, 4)) = 'HTTP') then
                                                    transf := sl[j] + ^m^j
                                                else
                                                    descricao := descricao + sl[j] + ^m^j;
                                        end;
                                    if transf <> '' then
                                        descricao := descricao + transf;

                                    resultado.add (traduzLetrasHTML(titulo));
                                    resultado.add (traduzLetrasHTML(descricao));
                                    url := hexDecode(url);
                                    resultado.add (url);
                                    numRegLidos := numRegLidos + 1;

                                    i := i + 2;
                                end;

                            i := i + 1;
                        end;

                    sl.free;

                    if (resultado.Count <> 0) then  // evita mensagens suprfluas no ltimo registro
                        begin
                            s := resultado[resultado.count-2];
                            p := pos (^m^j + 'Pesquisas relacionadas' + ^m^j, s);
                            if p <> 0 then
                                begin
                                    delete (s, p+2, 9999);
                                    resultado[resultado.count-2] := s;
                                end;
                        end;

                    delay (2000)   // evita que o google bloqueie o googlevox
                end;

            sintbip;
        end;

    if numRegLidos <> 0 then
         adicionaAosUltimos (busca);

    writeln;
    sintWriteln (intToStr(numRegLidos) + ' registros encontrados. Aperte enter');
    readkey;
    limpabuftec;
end;

end.

